; Instalan skript NSIS pro PLC

	; Include Modern UI (pedpipraven makra a dal prvky kter umouj snadn dosaen
	; "klasickho vzhledu" instaltoru
!include "MUI.nsh"
	
	; Hlavikov soubor pro plug-inu pro prci s registry 
!include "Registry.nsh"
	
	; Vloit hlavikov soubory s informacemi o verzi a revizi WinCNC
!include "SVNRevInfo.nsh"	; Informace o revizi (vytv SVN)
!include "WinCNCVersion.nsh"		; Informace o verzi
	; Vloit hlavikov soubor s informacemi o revizi PLC
!include /NONFATAL $%TempDir%\PlcRevInfo.nsh

; ********** Obecn **********

	; Pipravit si etzec s informacemi o revizi PLC
!ifdef PLC_REV
	!define PLC_REV_INFO _Rev_${PLC_REV}
	!if ${PLC_REVMODIFIED} == 1
		!define PLC_REV_INFO_TMP1 ${PLC_REV_INFO}_Modified
		!undef PLC_REV_INFO
		!define PLC_REV_INFO ${PLC_REV_INFO_TMP1}
	!endif
	!if ${PLC_REVMIXED} == 1
		!define PLC_REV_INFO_TMP2 ${PLC_REV_INFO}_Mixed
		!undef PLC_REV_INFO
		!define PLC_REV_INFO ${PLC_REV_INFO_TMP2}
	!endif
!else
	!define PLC_REV_INFO
!endif

	; Pipravit si etzec se jmnem
!ifdef PLC_NAME
	!define PLC_NAME_INFO "${PLC_NAME} (for WinCNC ${WINCNC_VER_MAJOR}.${WINCNC_VER_MINOR} Rev.${SVN_REV})"
!else
	!define PLC_NAME_INFO  "PLC (for WinCNC ${WINCNC_VER_MAJOR}.${WINCNC_VER_MINOR} Rev.${SVN_REV}"
!endif


	; Pipravit si etzec se jmnem vydavatele
!ifdef PLC_PUBLISHER
	!define PLC_PUBLISHER_INFO "${PLC_PUBLISHER}"
!else
	!define PLC_PUBLISHER_INFO "MEFI, s.r.o."
!endif

	; Pipravit si etzec s webovou adresou vydavatele
!ifdef PLC_WEB
	!define PLC_WEB_INFO "${PLC_WEB}"
!else
	!define PLC_WEB_INFO "www.mefi.cz"
!endif

	; Pipravit si etzec se telefonem na vydavatele
!ifdef PLC_PHONE
	!define PLC_PHONE_INFO "${PLC_PHONE}"
!else
	!define PLC_PHONE_INFO "+420251045113"
!endif


	; Jmno (zobrazuje se v zhlav instaltoru, ...)
Name "${PLC_NAME_INFO}"
	; Vstupn soubor (kam se zape vsledek pekladu skriptu)
!ifndef PLC_SETUPFILE
	!define PLC_SETUPFILE PLC
!endif
OutFile "$%OutputDir%\${PLC_SETUPFILE}Setup${PLC_REV_INFO}_for_WinCNC_${WINCNC_VER_MAJOR}_${WINCNC_VER_MINOR}_${SVN_REV}.exe"
; <><><>OutFile "$%OutputDir%\PLCSetup${PLC_REV_INFO}.exe"

	; Vchoz instalan adres (zatm ani nelze zmnit)
InstallDir "C:\CNC Machine Files"

; ********** Promnn **********
Var STARTMENU_FOLDER		; Adres pro zstupce v menu Start
Var MUI_TEMP				; Pomocn promnn, pouv se pi odinstalaci pi ruen poloek v menu Start	
Var CNCUSERFILES_FOLDER		; Adres CNC User Files
Var CNCMACHINEFILES_FOLDER	; Adres CNC Machine Files

; ********** Vloit soubory generovan Technolem **********
!include "$%ProjectDir%\PLC.nsi"

; ********** Nastaven parametr uivatelskho rozhran **********

	; Show a message box with a warning when the user wants to close the installer
!define MUI_ABORTWARNING


; ********** Parametry dialogu pro vbr jazyka **********

	; Uivatel m monost zvolit si jazyk instalace. Zvolen jazyk je poteba si zapamatovat
	; pro pt instalaci/odinstalaci, piem uloen nastaven je sdleno instaltorem WinCNC
	; a instaltorem PLC. Informace o zvolenm jazyku instaltoru se ukld do registru do kle
	; HKEY_LOCAL_MACHINE\Software\MEFI\WinCNC\Persistent a pi odinstalaci se neodstrauje.
!define MUI_LANGDLL_REGISTRY_ROOT "HKLM"				; Uchovvat dohromady pro vechny uivatele (WinCNC se bude instalovat jen jednou a ne jednotliv pro kadho uivatele)
!define MUI_LANGDLL_REGISTRY_KEY "Software\MEFI\WinCNC\Persistent" 
!define MUI_LANGDLL_REGISTRY_VALUENAME "InstallerLanguage"

	; Always show the language selection dialog, even if a language has been stored in 
	; the registry. The language stored in the registry will be selected by default.
	; (Pokad me instalovat nkdo jin a preferovat jin jazyk.)
!define MUI_LANGDLL_ALWAYSSHOW

; ********** Parametry dialogu pro vbr poloky v menu Start **********
	; Pamatovat si uivatelem zvolenou sloku v menu Start, do kter se vlo
	; zstupci pro spoutn WinCNC (pi opakovan instalaci se pouije jako 
	; vchoz, pi odinstalaci se odebere).
!define MUI_STARTMENUPAGE_REGISTRY_ROOT "HKLM" 
!define MUI_STARTMENUPAGE_REGISTRY_KEY "Software\MEFI\WinCNC" 
!define MUI_STARTMENUPAGE_REGISTRY_VALUENAME "StartMenuFolder"
	; Vchoz sloka, do kter se umst zstupci v menu Start
!define MUI_STARTMENUPAGE_DEFAULTFOLDER "MEFI\WinCNC"

; ********** Volba strnek prvodce instalac **********

	; Strnky pro instalaci
; !insertmacro MUI_PAGE_LICENSE $(MUILicense)
!insertmacro MUI_PAGE_STARTMENU WinCNC $STARTMENU_FOLDER	; Volba sloky v menu Start
!insertmacro MUI_PAGE_INSTFILES								; Pehled co bylo nainstalovno

	; Strnky pro odinstalaci  
!insertmacro MUI_UNPAGE_WELCOME					; vodn strnka odinstalace - monost stornovat
!insertmacro MUI_UNPAGE_INSTFILES				; Pehled co bylo odebrno



; ********** Volba jazyk pro uivatelsk rozhran instaltoru **********

	; Pro kad jazyk, kter m bt pro instaltor k dispozici, vloit odpovdajc dek.
	; Pozor: lokalizovan etzce mus bt zadan vdy pro vechny jazyky!
!insertmacro MUI_LANGUAGE "English" # first language is the default language
!insertmacro MUI_LANGUAGE "Czech"
  
;  !insertmacro MUI_LANGUAGE "French"
;  !insertmacro MUI_LANGUAGE "German"
;  !insertmacro MUI_LANGUAGE "Spanish"
;  !insertmacro MUI_LANGUAGE "SimpChinese"
;  !insertmacro MUI_LANGUAGE "TradChinese"
;  !insertmacro MUI_LANGUAGE "Japanese"
;  !insertmacro MUI_LANGUAGE "Korean"
;  !insertmacro MUI_LANGUAGE "Italian"
;  !insertmacro MUI_LANGUAGE "Dutch"
;  !insertmacro MUI_LANGUAGE "Danish"
;  !insertmacro MUI_LANGUAGE "Swedish"
;  !insertmacro MUI_LANGUAGE "Norwegian"
;  !insertmacro MUI_LANGUAGE "Finnish"
;  !insertmacro MUI_LANGUAGE "Greek"
;  !insertmacro MUI_LANGUAGE "Russian"
;  !insertmacro MUI_LANGUAGE "Portuguese"
;  !insertmacro MUI_LANGUAGE "PortugueseBR"
;  !insertmacro MUI_LANGUAGE "Polish"
;  !insertmacro MUI_LANGUAGE "Ukrainian"
;  !insertmacro MUI_LANGUAGE "Slovak"
;  !insertmacro MUI_LANGUAGE "Croatian"
;  !insertmacro MUI_LANGUAGE "Bulgarian"
;  !insertmacro MUI_LANGUAGE "Hungarian"
;  !insertmacro MUI_LANGUAGE "Thai"
;  !insertmacro MUI_LANGUAGE "Romanian"
;  !insertmacro MUI_LANGUAGE "Latvian"
;  !insertmacro MUI_LANGUAGE "Macedonian"
;  !insertmacro MUI_LANGUAGE "Estonian"
;  !insertmacro MUI_LANGUAGE "Turkish"
;  !insertmacro MUI_LANGUAGE "Lithuanian"
;  !insertmacro MUI_LANGUAGE "Catalan"
;  !insertmacro MUI_LANGUAGE "Slovenian"
;  !insertmacro MUI_LANGUAGE "Serbian"
;  !insertmacro MUI_LANGUAGE "SerbianLatin"
;  !insertmacro MUI_LANGUAGE "Arabic"
;  !insertmacro MUI_LANGUAGE "Farsi"
;  !insertmacro MUI_LANGUAGE "Hebrew"
;  !insertmacro MUI_LANGUAGE "Indonesian"
;  !insertmacro MUI_LANGUAGE "Mongolian"
;  !insertmacro MUI_LANGUAGE "Luxembourgish"
;  !insertmacro MUI_LANGUAGE "Albanian"
;  !insertmacro MUI_LANGUAGE "Breton"
;  !insertmacro MUI_LANGUAGE "Belarusian"
;  !insertmacro MUI_LANGUAGE "Icelandic"
;  !insertmacro MUI_LANGUAGE "Malay"
;  !insertmacro MUI_LANGUAGE "Bosnian"
;  !insertmacro MUI_LANGUAGE "Kurdish"



; ********** Vloen soubor s lokalizovanmi texty **********

	; Lokalizovan texty jsou uloeny v samostatnch souborech (pro kad
	; jazyk je jeden soubor).
!include "TextsEnglish.nsh"
!include "TextsCzech.nsh"


; ********** Reserve Files **********
  
  ; These files should be inserted before other files in the data block
  ; Keep these lines before any File command
  ; Only for solid compression (by default, solid compression is enabled for BZIP2 and LZMA)
  ; (Zad pouze to, e uveden soubory budou v instalanm souboru na zatku a jejich rozbalen
  ; dky tomu bude rychlej.)
!insertmacro MUI_RESERVEFILE_LANGDLL


; ********** Sekce pro instalaci **********
; Kad sekce odpovd jedn nainstalovan "komponent". S uivatelskou volbou komponent
; pro instalaci se zde zatm nepot. Komponenty mohou bt sdrueny do skupin (SectionGroup)

	; Typy instalace
InstType /NOCUSTOM						; (nepovolit "Vlastn")

	; Sekce "SetupActions" - skryt (nainstaluje se vdy, uivatel nem monost to ovlivnit,
	; nebo se nezobrazuje v dialogu na vbr komponent), reie instalace/odinstalace
Section "-SetupActions" secSetup
		; Tato sekce je soust vech typ instalace a uivatel to neme ovlivnit
	SectionIn 1 RO
	
		; Nastavit instalan adres (podle toho, co zvolil uivatel) a vytvoit ho.
	SetOutPath "$INSTDIR"
	
		; Odinstalovat pedchoz verzi: z registru zjistit, zda jsou zapsny informace pro
		; odinstalaci PLC. Pokud ne, pokraovat v instalaci (PLC nen nainstalovno).
		; Pokud ano, pest cestu k odinstaltoru, oznmit e pedchoz PLC bude odebrno
		; (monost stornovat cel proces) a spustit odinstaltor (s parametrem /S - na nic se nept).
	Push $R0
	ClearErrors
	ReadRegStr $R0 HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\WinCNC_PLC" "UninstallString"
	IfErrors UnInstPrevEnd
	MessageBox MB_OKCANCEL $(lsUnInstPrevWarn) IDOK ok IDCANCEL cancel
ok:
	DetailPrint $(lsUnInstPrev)
    ExecWait '"$R0" /S _?=$INSTDIR'
	Goto UnInstPrevEnd
cancel:
	DetailPrint $(lsAbort)
	Abort
	Goto UnInstPrevEnd
	
UnInstPrevEnd:
	Pop $R0
	
		; Zapsat do instalanho adrese odinstaltor.
	WriteUninstaller "$INSTDIR\Uninstall.exe"
		
		; Zapsat do registru informace pro odinstalaci (vloen poloky do seznamu
		; "Pidat nebo odebrat programy").
	WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\WinCNC_PLC" "DisplayName" "${PLC_NAME_INFO}"
	WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\WinCNC_PLC" "UninstallString" "$INSTDIR\Uninstall.exe"
	WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\WinCNC_PLC" "InstallLocation" "$INSTDIR"
	WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\WinCNC_PLC" "DisplayIcon" "$INSTDIR\Bin\WinCNC.exe,-0"
	WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\WinCNC_PLC" "Publisher" "${PLC_PUBLISHER_INFO}"
	WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\WinCNC_PLC" "HelpLink" "${PLC_WEB_INFO}"
	WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\WinCNC_PLC" "HelpTelephone" "${PLC_PHONE_INFO}"
	WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\WinCNC_PLC" "NoModify" 1
	WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\WinCNC_PLC" "NoRepair" 1
	
	; Vytvoit zstupce pro spoutn v nabdce Start
	!insertmacro MUI_STARTMENU_WRITE_BEGIN WinCNC
			; Vytvoit sloku v nabdce Start podle volby uivatele (vchoz - MEFI\WinCNC)	
		CreateDirectory "$SMPROGRAMS\$STARTMENU_FOLDER"
			; Vytvoit zstupce pro sputn odinstaltoru
		CreateShortCut "$SMPROGRAMS\$STARTMENU_FOLDER\UninstallPLC.lnk" "$INSTDIR\Uninstall.exe"
	!insertmacro MUI_STARTMENU_WRITE_END
	
SectionEnd



	; Sekce "PLC", v tto sekci se vytvo adrese CNCUSERFILES_FOLDER a CNCMACHINEFILES_FOLDER
	; se vemi potebnmi podadresi.
Section "PLC Files" secPLC
		; Tato sekce je soust vech typ instalace
	SectionIn 1

		; Nastavit instalan adres a vytvoit ho.
	SetOutPath "$INSTDIR"
	
		; Vytvoit adres CNCUSERFILES_FOLDER a jeho podadrese
	CreateDirectory "$CNCUSERFILES_FOLDER"
	CreateDirectory "$CNCUSERFILES_FOLDER\Bin"				; Podadres pro binrn soubory (exe, dll, ). (.\Bin)
	CreateDirectory "$CNCUSERFILES_FOLDER\System"			; Podadres pro systmov soubory. (.\System)
	CreateDirectory "$CNCUSERFILES_FOLDER\PLC"				; Podadres pro soubory programovatelnho interfacu stroje. (.\PLC)
	CreateDirectory "$CNCUSERFILES_FOLDER\Tab"				; Podadres pro tabulky. (.\Tab)
	CreateDirectory "$CNCUSERFILES_FOLDER\Config"			; Podadres pro konfiguran soubory. (.\Config)
	CreateDirectory "$CNCUSERFILES_FOLDER\Include"			; Podadres pro hlavikov soubory. (.\Include)
	CreateDirectory "$CNCUSERFILES_FOLDER\MAC"				; Podadres pro soubory s makrocykly. (.\MAC)
	CreateDirectory "$CNCUSERFILES_FOLDER\CYC"				; Podadres pro soubory s pevnmi cykly. (.\CYC)
	CreateDirectory "$CNCUSERFILES_FOLDER\PriorityBlock"	; Podadres pro soubory prioritnho bloku. (.\PriorityBlock)
	CreateDirectory "$CNCUSERFILES_FOLDER\NCP"				; Podadres pro partprogramy. (.\NCP)
	CreateDirectory "$CNCUSERFILES_FOLDER\Html"				; Podadres pro html soubory
	CreateDirectory "$CNCUSERFILES_FOLDER\PlugIns"			; Podadres pro plug-iny (.\PlugIns)
	CreateDirectory "$CNCUSERFILES_FOLDER\SoftMenu"			; Podadres pro soubory Soft Menu (.\SoftMenu)
	
		; Vytvoit adres CNCMACHINEFILES_FOLDER a jeho podadrese
	CreateDirectory "$CNCMACHINEFILES_FOLDER"
	CreateDirectory "$CNCMACHINEFILES_FOLDER\Bin"				; Podadres pro binrn soubory (exe, dll, ). (.\Bin)
	CreateDirectory "$CNCMACHINEFILES_FOLDER\System"			; Podadres pro systmov soubory. (.\System)
	CreateDirectory "$CNCMACHINEFILES_FOLDER\PLC"				; Podadres pro soubory programovatelnho interfacu stroje. (.\PLC)
	CreateDirectory "$CNCMACHINEFILES_FOLDER\Tab"				; Podadres pro tabulky. (.\Tab)
	CreateDirectory "$CNCMACHINEFILES_FOLDER\Config"			; Podadres pro konfiguran soubory. (.\Config)
	CreateDirectory "$CNCMACHINEFILES_FOLDER\Include"			; Podadres pro hlavikov soubory. (.\Include)
	CreateDirectory "$CNCMACHINEFILES_FOLDER\MAC"				; Podadres pro soubory s makrocykly. (.\MAC)
	CreateDirectory "$CNCMACHINEFILES_FOLDER\CYC"				; Podadres pro soubory s pevnmi cykly. (.\CYC)
	CreateDirectory "$CNCMACHINEFILES_FOLDER\PriorityBlock"		; Podadres pro soubory prioritnho bloku. (.\PriorityBlock)
	CreateDirectory "$CNCMACHINEFILES_FOLDER\NCP"				; Podadres pro partprogramy. (.\NCP)
	CreateDirectory "$CNCMACHINEFILES_FOLDER\Html"				; Podadres pro html soubory
	CreateDirectory "$CNCMACHINEFILES_FOLDER\PlugIns"			; Podadres pro plug-iny (.\PlugIns)
	CreateDirectory "$CNCMACHINEFILES_FOLDER\SoftMenu"			; Podadres pro soubory Soft Menu (.\SoftMenu)
	
		; Nainstalovat BIN soubory peloenho PLC
	File	"/oname=PLC\PLC_MAIN.BIN"		"$%OutputDir%\PLC_MAIN.BIN"
	File	"/oname=PLC\PLC_FAR0.BIN"		"$%OutputDir%\PLC_FAR0.BIN"
	File	"/oname=PLC\PLC_E003.BIN"		"$%OutputDir%\PLC_E003.BIN"
	File	"/oname=PLC\PLC_E004.BIN"		"$%OutputDir%\PLC_E004.BIN"
	File	"/oname=PLC\PLC_E005.BIN"		"$%OutputDir%\PLC_E005.BIN"
	File	"/oname=PLC\PLC_E006.BIN"		"$%OutputDir%\PLC_E006.BIN"
	File	"/oname=PLC\PLC_E007.BIN"		"$%OutputDir%\PLC_E007.BIN"
	File	"/oname=PLC\PLC_E008.BIN"		"$%OutputDir%\PLC_E008.BIN"
	File	"/oname=PLC\PLC_E009.BIN"		"$%OutputDir%\PLC_E009.BIN"
	File	"/oname=PLC\PLC_E010.BIN"		"$%OutputDir%\PLC_E010.BIN"
	File	"/oname=PLC\PLC_E011.BIN"		"$%OutputDir%\PLC_E011.BIN"
	File	"/oname=PLC\PLC_E012.BIN"		"$%OutputDir%\PLC_E012.BIN"
	File	"/oname=PLC\PLC_E013.BIN"		"$%OutputDir%\PLC_E013.BIN"
	File	"/oname=PLC\PLC_E014.BIN"		"$%OutputDir%\PLC_E014.BIN"
	File	"/oname=PLC\PLC_E015.BIN"		"$%OutputDir%\PLC_E015.BIN"
	File	"/oname=PLC\PLC_E016.BIN"		"$%OutputDir%\PLC_E016.BIN"
	File	"/oname=PLC\PLC_E017.BIN"		"$%OutputDir%\PLC_E017.BIN"
	
		; Nainstalovat ostatn soubory (dle projektu)
	call InstallPlcFiles
	
		; Zapsat konfiguraci do registru
	call InstallPlcConfig
SectionEnd
	

;--------------------------------
;Installer Functions

Function .onInit

  !insertmacro MUI_LANGDLL_DISPLAY
	
		; Nastavit cestu k adresum "CNC User Files" a "CNC Machine Files" (jejich umstn je zatm dno napevno)
	StrCpy $CNCUSERFILES_FOLDER		"C:\CNC User Files"
	StrCpy $CNCMACHINEFILES_FOLDER	"C:\CNC Machine Files"
  
FunctionEnd

 
;--------------------------------
;Uninstaller Section

Section "Uninstall"

	; ***** Odstranit poloky instalovan v sekci secPLC

		; Smazat BIN soubory peloenho PLC
	Delete	"$INSTDIR\PLC\PLC_MAIN.BIN"
	Delete	"$INSTDIR\PLC\PLC_FAR0.BIN"
	Delete	"$INSTDIR\PLC\PLC_E003.BIN"
	Delete	"$INSTDIR\PLC\PLC_E004.BIN"
	Delete	"$INSTDIR\PLC\PLC_E005.BIN"
	Delete	"$INSTDIR\PLC\PLC_E006.BIN"
	Delete	"$INSTDIR\PLC\PLC_E007.BIN"
	Delete	"$INSTDIR\PLC\PLC_E008.BIN"
	Delete	"$INSTDIR\PLC\PLC_E009.BIN"
	Delete	"$INSTDIR\PLC\PLC_E010.BIN"
	Delete	"$INSTDIR\PLC\PLC_E011.BIN"
	Delete	"$INSTDIR\PLC\PLC_E012.BIN"
	Delete	"$INSTDIR\PLC\PLC_E013.BIN"
	Delete	"$INSTDIR\PLC\PLC_E014.BIN"
	Delete	"$INSTDIR\PLC\PLC_E015.BIN"
	Delete	"$INSTDIR\PLC\PLC_E016.BIN"
	Delete	"$INSTDIR\PLC\PLC_E017.BIN"
	
		; Odstranit ostatn soubory (dle projektu)
	call un.InstallPlcFiles
	
		; Odstranit konfiguraci z registru (jen to co nen v HKLM\WinCNC\Machine, nebo
		; tento kl se poslze odstran cel)
	call un.InstallPlcConfig
	
		; Odstranit adres CNCUSERFILES_FOLDER vetn jeho podadres (odstrauj se pouze
		; przdn adrese - zstanou zachovny soubory nevytvoen instalac)
	RMDir "$CNCUSERFILES_FOLDER\Bin"				; Podadres pro binrn soubory (exe, dll, ). (.\Bin)
	RMDir "$CNCUSERFILES_FOLDER\System"				; Podadres pro systmov soubory. (.\System)
	RMDir "$CNCUSERFILES_FOLDER\PLC"				; Podadres pro soubory programovatelnho interfacu stroje. (.\PLC)
	RMDir "$CNCUSERFILES_FOLDER\Tab"				; Podadres pro tabulky. (.\Tab)
	RMDir "$CNCUSERFILES_FOLDER\Config"				; Podadres pro konfiguran soubory. (.\Config)
	RMDir "$CNCUSERFILES_FOLDER\Include"			; Podadres pro hlavikov soubory. (.\Include)
	RMDir "$CNCUSERFILES_FOLDER\MAC"				; Podadres pro soubory s makrocykly. (.\MAC)
	RMDir "$CNCUSERFILES_FOLDER\CYC"				; Podadres pro soubory s pevnmi cykly. (.\CYC)
	RMDir "$CNCUSERFILES_FOLDER\PriorityBlock"		; Podadres pro soubory prioritnho bloku. (.\PriorityBlock)
	RMDir "$CNCUSERFILES_FOLDER\NCP"				; Podadres pro partprogramy. (.\NCP)
	RMDir "$CNCUSERFILES_FOLDER\Html"				; Podadres pro html soubory
	RMDir "$CNCUSERFILES_FOLDER\PlugIns"			; Podadres pro plug-iny (.\PlugIns)
	RMDir "$CNCUSERFILES_FOLDER\SoftMenu"			; Podadres pro soubory Soft Menu (.\SoftMenu)
	RMDir	"$CNCUSERFILES_FOLDER"
	
		; Odstranit adres CNCMACHINEFILES_FOLDER vetn jeho podadres (odstrauj se pouze
		; przdn adrese - zstanou zachovny soubory nevytvoen instalac)
	RMDir "$CNCMACHINEFILES_FOLDER\Bin"				; Podadres pro binrn soubory (exe, dll, ). (.\Bin)
	RMDir "$CNCMACHINEFILES_FOLDER\System"			; Podadres pro systmov soubory. (.\System)
	RMDir "$CNCMACHINEFILES_FOLDER\PLC"				; Podadres pro soubory programovatelnho interfacu stroje. (.\PLC)
	RMDir "$CNCMACHINEFILES_FOLDER\Tab"				; Podadres pro tabulky. (.\Tab)
	RMDir "$CNCMACHINEFILES_FOLDER\Config"			; Podadres pro konfiguran soubory. (.\Config)
	RMDir "$CNCMACHINEFILES_FOLDER\Include"			; Podadres pro hlavikov soubory. (.\Include)
	RMDir "$CNCMACHINEFILES_FOLDER\MAC"				; Podadres pro soubory s makrocykly. (.\MAC)
	RMDir "$CNCMACHINEFILES_FOLDER\CYC"				; Podadres pro soubory s pevnmi cykly. (.\CYC)
	RMDir "$CNCMACHINEFILES_FOLDER\PriorityBlock"	; Podadres pro soubory prioritnho bloku. (.\PriorityBlock)
	RMDir "$CNCMACHINEFILES_FOLDER\NCP"				; Podadres pro partprogramy. (.\NCP)
	RMDir "$CNCMACHINEFILES_FOLDER\Html"			; Podadres pro html soubory
	RMDir "$CNCMACHINEFILES_FOLDER\PlugIns"			; Podadres pro plug-iny (.\PlugIns)
	RMDir "$CNCMACHINEFILES_FOLDER\SoftMenu"		; Podadres pro soubory Soft Menu (.\SoftMenu)
	RMDir	"$CNCMACHINEFILES_FOLDER"
	
	; Poloky v registru
	
		; Odstranit z registru konfiguraci (odstranit obsah kle HKLM\Software\MEFI\WinCNC\Machine, ale kl zachovat,
		; aby bylo mon WinCNC spustit bez PLC)
	DeleteRegKey HKLM "Software\MEFI\WinCNC\Machine"
	WriteRegStr		HKLM "Software\MEFI\WinCNC\Machine"		""		""
			
	; ***** Odstranit poloky instalovan v sekci secSetup
		; Smazat soubor odinstaltoru
	Delete "$INSTDIR\Uninstall.exe"
		; Smazat instalan adres
	RMDir "$INSTDIR"
	
		; Odstranit z registru informace pro odinstalaci (poloka seznamu
		; "Pidat nebo odebrat programy"
	DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\WinCNC_PLC"
		
	; Menu Start
		; Zjistit, do kter sloky menu Start byly uloeny zstupci
	!insertmacro MUI_STARTMENU_GETFOLDER WinCNC $MUI_TEMP
		; Odstranit zstupce pro odinstaltor
	Delete "$SMPROGRAMS\$MUI_TEMP\UninstallPLC.lnk"
		; Odstranit vechny przn nadazen adrese z nabdky Start
	StrCpy $MUI_TEMP "$SMPROGRAMS\$MUI_TEMP"
	startMenuDeleteLoop:
		ClearErrors
		RMDir $MUI_TEMP
		GetFullPathName $MUI_TEMP "$MUI_TEMP\.."
		IfErrors startMenuDeleteLoopDone
		StrCmp $MUI_TEMP $SMPROGRAMS startMenuDeleteLoopDone startMenuDeleteLoop
	startMenuDeleteLoopDone:

SectionEnd

;--------------------------------
;Uninstaller Functions

Function un.onInit

		; Nastavit cestu k adresum "CNC User Files" a "CNC Machine Files" (jejich umstn je zatm dno napevno)
	StrCpy $CNCUSERFILES_FOLDER		"C:\CNC User Files"
	StrCpy $CNCMACHINEFILES_FOLDER	"C:\CNC Machine Files"

FunctionEnd



